Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.query
Class ImportedFunctionLibrary

    java.lang.Object
      net.sf.saxon.query.ImportedFunctionLibrary

All Implemented Interfaces:
  Serializable, FunctionLibrary, XQueryFunctionBinder

    public class ImportedFunctionLibrary

extends Object
implements FunctionLibrary, XQueryFunctionBinder

This implementation of FunctionLibrary contains all the functions imported into a Query Module. It is implemented as a view of the "global" XQueryFunctionLibrary for the whole query, selecting only those functions that are in an imported namespace.

See Also:
  Serialized Form

Constructor Summary
`ImportedFunctionLibrary(QueryModule importingModule, XQueryFunctionLibrary baseLibrary)` Create an imported function library

Method Summary
`void` | `addImportedNamespace(String namespace)` Add an imported namespace
`Expression` | `bind(StructuredQName functionName, Expression[] staticArgs, StaticContext env, Container container)` Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`XQueryFunction` | `getDeclaration(StructuredQName functionName, Expression[] staticArgs)` Get the function declaration corresponding to a given function name and arity
`SequenceType[]` | `getFunctionSignature(StructuredQName functionName, int arity)` Test whether a function with a given name and arity is available; if so, return its signature.
`void` | `setImportingModule(QueryModule importingModule)` Set the module that imports this function libary

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ImportedFunctionLibrary

    public ImportedFunctionLibrary(QueryModule importingModule,
                                   XQueryFunctionLibrary baseLibrary)

  Create an imported function library

  Parameters:
    `importingModule` - the module importing the library
    `baseLibrary` - the function library of which this is a subset view

Method Detail

### addImportedNamespace

    public void addImportedNamespace(String namespace)

  Add an imported namespace

  Parameters:
    `namespace` - the imported namespace

### bind

    public Expression bind(StructuredQName functionName,
                           Expression[] staticArgs,
                           StaticContext env,
                           Container container)
                    throws XPathException

  Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Specified by:
    `bind` in interface `FunctionLibrary`
  Parameters:
    `functionName` - the name of the function to be bound
    `staticArgs` - The expressions supplied statically in arguments to the function call. The length of this array represents the arity of the function. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality()) may be used as part of the binding algorithm. In some cases it may be possible for the function to be pre-evaluated at compile time, for example if these expressions are all constant values.

    The conventions of the XPath language demand that the results of a function depend only on the values of the expressions supplied as arguments, and not on the form of those expressions. For example, the result of f(4) is expected to be the same as f(2+2). The actual expression is supplied here to enable the binding mechanism to select the most efficient possible implementation (including compile-time pre-evaluation where appropriate).
    `env` -
    `container` -
  Returns:
    An object representing the function to be called, if one is found; null if no function was found matching the required name and arity.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function.

### getDeclaration

    public XQueryFunction getDeclaration(StructuredQName functionName,
                                         Expression[] staticArgs)

  Get the function declaration corresponding to a given function name and arity

  Specified by:
    `getDeclaration` in interface `XQueryFunctionBinder`
  Parameters:
    `functionName` - the name of the function as a QName
    `staticArgs` - the expressions supplied as arguments in the function call (typically, we only need to know the number of arguments)
  Returns:
    the XQueryFunction if there is one, or null if not.

### copy

    public FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Specified by:
    `copy` in interface `FunctionLibrary`
  Returns:
    a copy of this function library. This must be an instance of the original class.

### setImportingModule

    public void setImportingModule(QueryModule importingModule)

  Set the module that imports this function libary

  Parameters:
    `importingModule` - the importing module

### getFunctionSignature

    public SequenceType[] getFunctionSignature(StructuredQName functionName,
                                               int arity)

  Test whether a function with a given name and arity is available; if so, return its signature. This supports the function-available() function in XSLT; it is also used to support higher-order functions introduced in XQuery 1.1.

  This method may be called either at compile time or at run time. If the function library is to be used only in an XQuery or free-standing XPath environment, this method may throw an UnsupportedOperationException.

  Specified by:
    `getFunctionSignature` in interface `FunctionLibrary`
  Parameters:
    `functionName` - the qualified name of the function being called
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return true if there is some function of this name available for calling.
  Returns:
    if a function of this name and arity is available for calling, then the type signature of the function, as an array of sequence types in which the zeroth entry represents the return type; or a zero-length array if the function exists but the signature is not known; or null if the function does not exist

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.